searchNodes=[{"type":"module","title":"Gnat","doc":"The primary interface for interacting with NATS","ref":"Gnat.html"},{"type":"function","title":"Gnat.active_subscriptions/1","doc":"Get the number of active subscriptions","ref":"Gnat.html#active_subscriptions/1"},{"type":"function","title":"Gnat.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Gnat.html#child_spec/1"},{"type":"function","title":"Gnat.ping/1","doc":"Ping the NATS server This correlates to the PING command in the NATS protocol. If the NATS server responds with a PONG message this function will return :ok { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . ping ( gnat )","ref":"Gnat.html#ping/1"},{"type":"function","title":"Gnat.pub/4","doc":"Publish a message { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . pub ( gnat , &quot;characters&quot; , &quot;Ron Swanson&quot; ) If you want to provide a reply address to receive a response you can pass it as an option. See request-reply pattern . { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . pub ( gnat , &quot;characters&quot; , &quot;Star Lord&quot; , reply_to : &quot;me&quot; ) If you want to publish a message with headers you can pass the :headers key in the opts like this. { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . pub ( gnat , &quot;listen&quot; , &quot;Yo&quot; , headers : [ { &quot;foo&quot; , &quot;bar&quot; } ] ) Headers must be passed as a t:headers() value (a list of tuples). Sending and parsing headers has more overhead than typical nats messages (see the Nats 2.2 release notes for details ), so only use them when they are really valuable.","ref":"Gnat.html#pub/4"},{"type":"function","title":"Gnat.request/4","doc":"Send a request and listen for a response synchronously Following the nats request-reply pattern this function generates a one-time topic to receive replies and then sends a message to the provided topic. Supported options: receive_timeout - An integer number of milliseconds to wait for a response. Defaults to 60_000 headers - A set of headers you want to send with the request (see Gnat.pub/4 ) { :ok , gnat } = Gnat . start_link ( ) case Gnat . request ( gnat , &quot;i_can_haz_cheezburger&quot; , &quot;plZZZZ?!?!?&quot; ) do { :ok , %{ body : delicious_cheezburger } } -&gt; :yum { :error , :timeout } -&gt; :sad_cat end No Responders If you send a request to a topic that has no registered listeners, it is sometimes convenient to find out right away, rather than waiting for a timeout to occur. In order to support this use-case, you can start your Gnat connection with the no_responders: true option and this function will return very quickly with an {:error, :no_responders} value. This behavior also works with request_multi/4","ref":"Gnat.html#request/4"},{"type":"function","title":"Gnat.request_multi/4","doc":"Send a request and listen for multiple responses synchronously This function makes it easy to do a scatter-gather operation where you wait for a limited time and optionally a maximum number of replies. Supported options: receive_timeout - An integer number of milliseconds to wait for responses. Defaults to 60_000 max_messages - An integer number of messages to listen for. Defaults to -1 meaning unlimited headers - A set of headers you want to send with the request (see Gnat.pub/4 ) { :ok , gnat } = Gnat . start_link ( ) { :ok , responses } = Gnat . request_multi ( gnat , &quot;i_can_haz_fries&quot; , &quot;plZZZZZ!?!?&quot; , max_messages : 5 ) Enum . count ( responses ) #=&gt; 5","ref":"Gnat.html#request_multi/4"},{"type":"function","title":"Gnat.server_info/1","doc":"Get information about the NATS server the connection is for","ref":"Gnat.html#server_info/1"},{"type":"function","title":"Gnat.start_link/2","doc":"Starts a connection to a nats broker { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 } ) # if the server requires TLS you can start a connection with: { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , tls : true } ) # if the server requires TLS and a client certificate you can start a connection with: { :ok , gnat } = Gnat . start_link ( %{ tls : true , ssl_opts : [ certfile : &quot;client-cert.pem&quot; , keyfile : &quot;client-key.pem&quot; ] } ) # you can customize default &quot;_INBOX.&quot; inbox prefix with: { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , inbox_prefix : &quot;my_prefix._INBOX.&quot; } ) # you can use IPv6 addresses too { :ok , gnat } = Gnat . start_link ( %{ host : &#39;::1&#39; , port : 4222 , tcp_opts : [ :inet6 , :binary ] } ) You can also pass arbitrary SSL or TCP options in the tcp_opts and ssl_opts keys. If you pass custom TCP options please include :binary . Gnat uses binary matching to parse messages. The final opts argument will be passed to the GenServer.start_link call so you can pass things like [name: :gnat_connection] .","ref":"Gnat.html#start_link/2"},{"type":"function","title":"Gnat.stop/1","doc":"Gracefully shuts down a connection { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . stop ( gnat )","ref":"Gnat.html#stop/1"},{"type":"function","title":"Gnat.sub/4","doc":"Subscribe to a topic Supported options: queue_group: a string that identifies which queue group you want to join By default each subscriber will receive a copy of every message on the topic. When a queue_group is supplied messages will be spread among the subscribers in the same group. (see nats queueing ) The subscribed process will begin receiving messages with a structure of sent_message/0 { :ok , gnat } = Gnat . start_link ( ) { :ok , subscription } = Gnat . sub ( gnat , self ( ) , &quot;topic&quot; ) receive do { :msg , %{ topic : &quot;topic&quot; , body : body } } -&gt; IO . puts &quot;Received: \#{ body } &quot; end","ref":"Gnat.html#sub/4"},{"type":"function","title":"Gnat.unsub/3","doc":"Unsubscribe from a topic Supported options: max_messages - Number of messages to be received before automatically unsubscribed This correlates to the UNSUB command in the nats protocol. By default the unsubscribe is affected immediately, but an optional max_messages value can be provided which will allow max_messages to be received before affecting the unsubscribe. This is especially useful for request/reply patterns. { :ok , gnat } = Gnat . start_link ( ) { :ok , subscription } = Gnat . sub ( gnat , self ( ) , &quot;my_inbox&quot; ) :ok = Gnat . unsub ( gnat , subscription ) # OR :ok = Gnat . unsub ( gnat , subscription , max_messages : 2 )","ref":"Gnat.html#unsub/3"},{"type":"type","title":"Gnat.connection_settings/0","doc":"connection_timeout - limits how long it can take to establish a connection to a server host - The location of the NATS server port - The port the NATS server is listening on ssl_opts - Options for connecting over SSL tcp_opts - Options for connecting over TCP tls - If the server should use a TLS connection inbox_prefix - Prefix to use for the message inbox of this connection no_responders - Enable the no responders behavior (see Gnat.request/4 )","ref":"Gnat.html#t:connection_settings/0"},{"type":"type","title":"Gnat.headers/0","doc":"","ref":"Gnat.html#t:headers/0"},{"type":"type","title":"Gnat.message/0","doc":"A message received from NATS will be delivered to your process in this form. Please note that the :reply_to and :headers keys are optional. They will only be present if the message was received from the NATS server with headers or a reply_to topic gnat - The Gnat connection topic - The topic on which the message arrived body - The raw payload of the message sid - The subscription ID corresponding to this message. You generally won't need to use this value directly. reply_to - A topic supplied for expected replies headers - A set of NATS message headers on the message","ref":"Gnat.html#t:message/0"},{"type":"type","title":"Gnat.sent_message/0","doc":"","ref":"Gnat.html#t:sent_message/0"},{"type":"type","title":"Gnat.server_info/0","doc":"Info Protocol client_id - An optional unsigned integer (64 bits) representing the internal client identifier in the server. This can be used to filter client connections in monitoring, correlate with error logs, etc... client_ip - The IP address the client is connecting from cluster - The name of the cluster if any cluster_dynamic - If the cluster is dynamic connect_urls - An optional list of server urls that a client can connect to. ws_connect_urls - An optional list of server urls that a websocket client can connect to. git_commit - The git commit associated with this NATS version go - The version of golang the NATS server was built with headers - If messages can have headers in them host - The IP address used to start the NATS server, by default this will be 0.0.0.0 and can be configured with -client_advertise host:port jetstream - If the server is using JetStream features max_payload - Maximum payload size, in bytes, that the server will accept from the client port - The port number the NATS server is configured to listen on proto - An integer indicating the protocol version of the server. The server version 1.2.0 sets this to 1 to indicate that it supports the &quot;Echo&quot; feature. server_id - The unique identifier of the NATS server server_name - A name for the server version - The version of the NATS server ldm - If the server supports Lame Duck Mode notifications, and the current server has transitioned to lame duck, ldm will be set to true. auth_required - If this is set, then the client should try to authenticate upon connect. tls_required - If this is set, then the client must perform the TLS/1.2 handshake. Note, this used to be ssl_required and has been updated along with the protocol from SSL to TLS. tls_verify - If this is set, the client must provide a valid certificate during the TLS handshake. tls_available - If the server can use TLS","ref":"Gnat.html#t:server_info/0"},{"type":"type","title":"Gnat.t/0","doc":"","ref":"Gnat.html#t:t/0"},{"type":"module","title":"Gnat.ConnectionSupervisor","doc":"A process that can supervise a named connection for you If you would like to supervise a Gnat connection and have it automatically re-connect in case of failure you can use this module in your supervision tree. It takes a map with the following data: gnat_supervisor_settings = %{ name : :gnat , # (required) the registered named you want to give the Gnat connection backoff_period : 4_000 , # number of milliseconds to wait between consecutive reconnect attempts (default: 2_000) connection_settings : [ %{ host : &#39;10.0.0.100&#39; , port : 4222 } , %{ host : &#39;10.0.0.101&#39; , port : 4222 } , ] } The connection settings can specify all of the same values that you pass to Gnat.start_link/1 . Each time a connection is attempted we will use one of the provided connection settings to open the connection. This is a simplistic way of load balancing your connections across a cluster of nats nodes and allowing failover to other nodes in the cluster if one goes down. To use this in your supervision tree add an entry like this: import Supervisor.Spec worker ( Gnat.ConnectionSupervisor , [ gnat_supervisor_settings , [ name : :my_connection_supervisor ] ] ) The second argument is used as GenServer options so you can give the supervisor a registered name as well if you like. Now in the rest of your code you can call things like: :ok = Gnat . pub ( :gnat , &quot;subject&quot; , &quot;message&quot; ) And it will use your supervised connection. If the connection is down when you call that function (or dies during that function) it will raise an error.","ref":"Gnat.ConnectionSupervisor.html"},{"type":"function","title":"Gnat.ConnectionSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Gnat.ConnectionSupervisor.html#child_spec/1"},{"type":"function","title":"Gnat.ConnectionSupervisor.start_link/2","doc":"","ref":"Gnat.ConnectionSupervisor.html#start_link/2"},{"type":"module","title":"Gnat.ConsumerSupervisor","doc":"A process that can supervise consumers for you If you want to subscribe to a few topics and have that subscription last across restarts for you, then this worker can be of help. It also spawns a supervised Task for each message it receives. This way errors in message processing don't crash the consumers, but you will still get SASL reports that you can send to services like honeybadger. To use this just add an entry to your supervision tree like this: consumer_supervisor_settings = %{ connection_name : :name_of_supervised_connection , module : MyApp.Server , # a module that implements the Gnat.Server behaviour subscription_topics : [ %{ topic : &quot;rpc.MyApp.search&quot; , queue_group : &quot;rpc.MyApp.search&quot; } , %{ topic : &quot;rpc.MyApp.create&quot; , queue_group : &quot;rpc.MyApp.create&quot; } , ] , } worker ( Gnat.ConsumerSupervisor , [ consumer_supervisor_settings , [ name : :rpc_consumer ] ] , shutdown : 30_000 ) The second argument is a keyword list that gets used as the GenServer options so you can pass a name that you want to register for the consumer process if you like. The :consuming_function specifies which module and function to call when messages arrive. The function will be called with a single argument which is a Gnat.message/0 just like you get when you call Gnat.sub/4 directly. You can have a single consumer that subscribes to multiple topics or multiple consumers that subscribe to different topics and call different consuming functions. It is recommended that your ConsumerSupervisor s are present later in your supervision tree than your ConnectionSupervisor . That way during a shutdown the ConsumerSupervisor can attempt a graceful shutdown of the consumer before shutting down the connection. If you want this consumer supervisor to host a NATS service, then you can specify a module that implements the Gnat.Services.Server behavior. You'll need to specify the service_definition field in the consumer supervisor settings and conforms to the Gnat.Services.Server.service_configuration type. Here is an example of configuring the consumer supervisor to manage a service: consumer_supervisor_settings = %{ connection_name : :name_of_supervised_connection , module : MyApp.Service , # a module that implements the Gnat.Services.Server behaviour service_definition : %{ name : &quot;exampleservice&quot; , description : &quot;This is an example service&quot; , version : &quot;0.1.0&quot; , endpoints : [ %{ name : &quot;add&quot; , group_name : &quot;calc&quot; , } , %{ name : &quot;sub&quot; , group_name : &quot;calc&quot; } ] } } worker ( Gnat.ConsumerSupervisor , [ consumer_supervisor_settings , [ name : :myservice_consumer ] ] , shutdown : 30_000 ) It's also possible to pass a %{consuming_function: {YourModule, :your_function}} rather than a :module in your settings. In that case no error handling or replying is taking care of for you, microservices cannot be used, and it will be up to your function to take whatever action you want with each message.","ref":"Gnat.ConsumerSupervisor.html"},{"type":"function","title":"Gnat.ConsumerSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Gnat.ConsumerSupervisor.html#child_spec/1"},{"type":"function","title":"Gnat.ConsumerSupervisor.start_link/2","doc":"","ref":"Gnat.ConsumerSupervisor.html#start_link/2"},{"type":"module","title":"Gnat.Jetstream","doc":"Provides functions for interacting with a NATS Jetstream server.","ref":"Gnat.Jetstream.html"},{"type":"function","title":"Gnat.Jetstream.ack/1","doc":"Sends AckAck acknowledgement to the server. Acknowledges a message was completely handled.","ref":"Gnat.Jetstream.html#ack/1"},{"type":"function","title":"Gnat.Jetstream.ack_next/2","doc":"Sends AckNext acknowledgement to the server. Acknowledges the message was handled and requests delivery of the next message to the reply subject. Only applies to Pull-mode.","ref":"Gnat.Jetstream.html#ack_next/2"},{"type":"function","title":"Gnat.Jetstream.ack_progress/1","doc":"Sends AckProgress acknowledgement to the server. When sent before the AckWait period indicates that work is ongoing and the period should be extended by another equal to AckWait .","ref":"Gnat.Jetstream.html#ack_progress/1"},{"type":"function","title":"Gnat.Jetstream.ack_term/1","doc":"Sends AckTerm acknowledgement to the server. Instructs the server to stop redelivery of a message without acknowledging it as successfully processed.","ref":"Gnat.Jetstream.html#ack_term/1"},{"type":"function","title":"Gnat.Jetstream.nack/1","doc":"Sends AckNak acknowledgement to the server. Signals that the message will not be processed now and processing can move onto the next message. NAK'd message will be retried.","ref":"Gnat.Jetstream.html#nack/1"},{"type":"module","title":"Gnat.Jetstream.API.Consumer","doc":"A module representing a NATS JetStream Consumer. Learn more about consumers: https://docs.nats.io/nats-concepts/jetstream/consumers The Jetstream.API.Consumer struct The struct's only mandatory field to set is the :stream_name . The rest will have the NATS default values set. Note that consumers are ephemeral by default. Set the :durable_name to make it durable. Consumer struct fields explanation: :stream_name - name of a stream the consumer is pointing at. :domain - JetStream domain the stream is on. :ack_policy - how the messages should be acknowledged. It has the following options: :explicit - the default policy. It means that each individual message must be acknowledged. It is the only allowed option for pull consumers. :none - no need to ack messages, the server will assume ack on delivery. :all - only the last received message needs to be acked, all the previous messages received are automatically acknowledged. :ack_wait - time in nanoseconds that server will wait for an ack for any individual. If an ack is not received in time, the message will be redelivered. :backoff - list of durations that represents a retry timescale for NAK'd messages or those being normally retried. :deliver_group - when set, will only deliver messages to subscriptions matching that group. :deliver_policy - specifies where in the stream it wants to start receiving messages. It has the following options: :all - the default policy. The consumer will start receiving from the earliest available message. :last - the consumer will start receiving messages with the last message added to the stream. :new - the consumer will only start receiving messages that were created after the customer was created. :by_start_sequence - the consumer is required to specify :opt_start_seq , the sequence number to start on. It will receive the closest available message moving forward in the sequence should the message specified have been removed based on the stream limit policy. :by_start_time - the consumer will start with messages on or after this time. The consumer is required to specify :opt_start_time , the time in the stream to start at. :last_per_subject - the consumer will start with the latest one for each filtered subject currently in the stream. :deliver_subject - the subject to deliver observed messages. Not allowed for pull subscriptions. A delivery subject is required for queue subscribing as it configures a subject that all the queue consumers should listen on. :description - a short description of the purpose of this customer. :durable_name - the name of the consumer, which the server will track, allowing resuming consumption where left off. By default, a consumer is ephemeral. To make the consumer durable, set the name. See naming . :filter_subject - when consuming from a stream with a wildcard subject, this allows you to select a subset of the full wildcard subject to receive messages from. :flow_control - when set to true, an empty message with Status header 100 and a reply subject will be sent. Consumers must reply to these messages to control the rate of message delivery. :headers_only - delivers only the headers of messages in the stream and not the bodies. Additionally adds the Nats-Msg-Size header to indicate the size of the removed payload. :idle_heartbeat - if set, the server will regularly send a status message to the client while there are no new messages to send. This lets the client know that the JetStream service is still up and running, even when there is no activity on the stream. The message status header will have a code of 100. Unlike :flow_control , it will have no reply to address. It may have a description like &quot;Idle Heartbeat&quot;. :inactive_threshold - duration that instructs the server to clean up ephemeral consumers that are inactive for that long. :max_ack_pending - it sets the maximum number of messages without an acknowledgement that can be outstanding, once this limit is reached, message delivery will be suspended. It cannot be used with :ack_none ack policy. This maximum number of pending acks applies for all the consumer's subscriber processes. A value of -1 means there can be any number of pending acks (i.e. no flow control). :max_batch - the largest batch property that may be specified when doing a pull on a Pull consumer. :max_deliver - the maximum number of times a specific message will be delivered. Applies to any message that is re-sent due to ack policy. :max_expires - the maximum expires value that may be set when doing a pull on a Pull consumer. :max_waiting - the number of pulls that can be outstanding on a pull consumer, pulls received after this is reached are ignored. :opt_start_seq - use with :deliver_policy set to :by_start_sequence . It represents the sequence number to start consuming on. :opt_start_time - use with :deliver_policy set to :by_start_time . It represents the time to start consuming at. :rate_limit_bps - used to throttle the delivery of messages to the consumer, in bits per second. :replay_policy - it applies when the :deliver_policy is set to :all , :by_start_sequence or :by_start_time . It has the following options: :instant - the default policy. The messages will be pushed to the client as fast as possible. :original - the messages in the stream will be pushed to the client at the same rate that they were originally received. :sample_freq - Sets the percentage of acknowledgements that should be sampled for observability, 0-100. This value is a binary and for example allows both 30 and 30% as valid values.","ref":"Gnat.Jetstream.API.Consumer.html"},{"type":"function","title":"Gnat.Jetstream.API.Consumer.create/2","doc":"Creates a consumer. When consumer's :durable_name field is not set, the function creates an ephemeral consumer. Otherwise, it creates a durable consumer. Examples iex&gt; { :ok , _response } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;astream&quot; , subjects : [ &quot;subject&quot; ] } ) iex&gt; { :ok , %{ name : &quot;consumer&quot; , stream_name : &quot;astream&quot; } } = Gnat.Jetstream.API.Consumer . create ( :gnat , % Gnat.Jetstream.API.Consumer { durable_name : &quot;consumer&quot; , stream_name : &quot;astream&quot; } ) iex&gt; { :ok , _response } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;astream&quot; , subjects : [ &quot;subject&quot; ] } ) iex&gt; { :error , %{ &quot;description&quot; =&gt; &quot;consumer delivery policy is deliver by start sequence, but optional start sequence is not set&quot; } } = Gnat.Jetstream.API.Consumer . create ( :gnat , % Gnat.Jetstream.API.Consumer { durable_name : &quot;consumer&quot; , stream_name : &quot;astream&quot; , deliver_policy : :by_start_sequence } )","ref":"Gnat.Jetstream.API.Consumer.html#create/2"},{"type":"function","title":"Gnat.Jetstream.API.Consumer.delete/4","doc":"Deletes a consumer. Examples iex&gt; { :ok , _response } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;astream&quot; , subjects : [ &quot;subject&quot; ] } ) iex&gt; { :ok , _response } = Gnat.Jetstream.API.Consumer . create ( :gnat , % Gnat.Jetstream.API.Consumer { durable_name : &quot;consumer&quot; , stream_name : &quot;astream&quot; } ) iex&gt; Gnat.Jetstream.API.Consumer . delete ( :gnat , &quot;astream&quot; , &quot;consumer&quot; ) :ok iex&gt; { :error , %{ &quot;code&quot; =&gt; 404 , &quot;description&quot; =&gt; &quot;stream not found&quot; } } = Gnat.Jetstream.API.Consumer . delete ( :gnat , &quot;wrong_stream&quot; , &quot;consumer&quot; )","ref":"Gnat.Jetstream.API.Consumer.html#delete/4"},{"type":"function","title":"Gnat.Jetstream.API.Consumer.info/4","doc":"Information about the consumer. Examples iex&gt; { :ok , _response } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;astream&quot; , subjects : [ &quot;subject&quot; ] } ) iex&gt; { :ok , _response } = Gnat.Jetstream.API.Consumer . create ( :gnat , % Gnat.Jetstream.API.Consumer { durable_name : &quot;consumer&quot; , stream_name : &quot;astream&quot; } ) iex&gt; { :ok , %{ created : _ } } = Gnat.Jetstream.API.Consumer . info ( :gnat , &quot;astream&quot; , &quot;consumer&quot; ) iex&gt; { :error , %{ &quot;code&quot; =&gt; 404 , &quot;description&quot; =&gt; &quot;stream not found&quot; } } = Gnat.Jetstream.API.Consumer . info ( :gnat , &quot;wrong_stream&quot; , &quot;consumer&quot; )","ref":"Gnat.Jetstream.API.Consumer.html#info/4"},{"type":"function","title":"Gnat.Jetstream.API.Consumer.list/3","doc":"Paged list of known consumers, including their current info. Examples iex&gt; { :ok , _response } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;astream&quot; , subjects : [ &quot;subject&quot; ] } ) iex&gt; { :ok , %{ consumers : _ , limit : 1024 , offset : 0 , total : _ } } = Gnat.Jetstream.API.Consumer . list ( :gnat , &quot;astream&quot; ) iex&gt; { :error , %{ &quot;code&quot; =&gt; 404 , &quot;description&quot; =&gt; &quot;stream not found&quot; } } = Gnat.Jetstream.API.Consumer . list ( :gnat , &quot;wrong_stream&quot; )","ref":"Gnat.Jetstream.API.Consumer.html#list/3"},{"type":"function","title":"Gnat.Jetstream.API.Consumer.request_next_message/6","doc":"Requests a next message from a stream to be consumed. The response (consumed message)will be sent on the subject given as the reply_to parameter. Options batch - How many messages to receive. Messages will be sent to the reply_to subject separately. Defaults to 1. expires - Time in nanoseconds the request will be kept in the server. Once this time passes a message with empty body and topic set to reply_to subject is sent. Useful when polling the server frequently and not wanting the pull requests to accumulate. By default, the pull request stays in the server until a message comes. no_wait - Boolean value which indicates whether the pull request should be accumulated on the server. When set to true and no message is present to be consumed, a message with empty body and topic value set to reply_to is sent. Defaults to false. Example iex&gt; { :ok , _response } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;astream&quot; , subjects : [ &quot;subject&quot; ] } ) iex&gt; { :ok , _response } = Gnat.Jetstream.API.Consumer . create ( :gnat , % Gnat.Jetstream.API.Consumer { durable_name : &quot;consumer&quot; , stream_name : &quot;astream&quot; } ) iex&gt; { :ok , _sid } = Gnat . sub ( :gnat , self ( ) , &quot;reply_subject&quot; ) iex&gt; :ok = Gnat.Jetstream.API.Consumer . request_next_message ( :gnat , &quot;astream&quot; , &quot;consumer&quot; , &quot;reply_subject&quot; ) iex&gt; :ok = Gnat . pub ( :gnat , &quot;subject&quot; , &quot;message1&quot; ) iex&gt; assert_receive { :msg , %{ body : &quot;message1&quot; , topic : &quot;subject&quot; } }","ref":"Gnat.Jetstream.API.Consumer.html#request_next_message/6"},{"type":"type","title":"Gnat.Jetstream.API.Consumer.config/0","doc":"","ref":"Gnat.Jetstream.API.Consumer.html#t:config/0"},{"type":"type","title":"Gnat.Jetstream.API.Consumer.consumers/0","doc":"","ref":"Gnat.Jetstream.API.Consumer.html#t:consumers/0"},{"type":"type","title":"Gnat.Jetstream.API.Consumer.info/0","doc":"","ref":"Gnat.Jetstream.API.Consumer.html#t:info/0"},{"type":"type","title":"Gnat.Jetstream.API.Consumer.t/0","doc":"","ref":"Gnat.Jetstream.API.Consumer.html#t:t/0"},{"type":"module","title":"Gnat.Jetstream.API.KV","doc":"API for interacting with the Key/Value store functionality in Nats Jetstream. Learn about the Key/Value store: https://docs.nats.io/nats-concepts/jetstream/key-value-store","ref":"Gnat.Jetstream.API.KV.html"},{"type":"function","title":"Gnat.Jetstream.API.KV.contents/3","doc":"Get all the non-deleted key-value pairs for a Bucket Examples iex&gt; { :ok , %{ &quot;key1&quot; =&gt; &quot;value1&quot; } } = Jetstream.API.KV . contents ( :gnat , &quot;my_bucket&quot; )","ref":"Gnat.Jetstream.API.KV.html#contents/3"},{"type":"function","title":"Gnat.Jetstream.API.KV.create_bucket/3","doc":"Create a new Key/Value bucket. Can include the following options :history - How many historic values to keep per key (defaults to 1, max of 64) :ttl - How long to keep values for (in nanoseconds) :max_bucket_size - The max number of bytes the bucket can hold :max_value_size - The max number of bytes a value may be :description - A description for the bucket :replicas - How many replicas of the data to store :storage - Storage backend to use (:file, :memory) :placement - A map with :cluster (required) and :tags (optional) Examples iex&gt;{:ok, info} = Jetstream.API.KV.create_bucket(:gnat, &quot;my_bucket&quot;)","ref":"Gnat.Jetstream.API.KV.html#create_bucket/3"},{"type":"function","title":"Gnat.Jetstream.API.KV.create_key/5","doc":"Create a Key in a Key/Value Bucket Examples iex&gt; :ok = Jetstream.API.KV . create_key ( :gnat , &quot;my_bucket&quot; , &quot;my_key&quot; , &quot;my_value&quot; )","ref":"Gnat.Jetstream.API.KV.html#create_key/5"},{"type":"function","title":"Gnat.Jetstream.API.KV.delete_bucket/2","doc":"Delete a Key/Value bucket Examples iex&gt;:ok = Jetstream.API.KV.delete_bucket(:gnat, &quot;my_bucket&quot;)","ref":"Gnat.Jetstream.API.KV.html#delete_bucket/2"},{"type":"function","title":"Gnat.Jetstream.API.KV.delete_key/4","doc":"Delete a Key from a K/V Bucket Examples iex&gt; :ok = Jetstream.API.KV . delete_key ( :gnat , &quot;my_bucket&quot; , &quot;my_key&quot; )","ref":"Gnat.Jetstream.API.KV.html#delete_key/4"},{"type":"function","title":"Gnat.Jetstream.API.KV.get_value/3","doc":"Get the value for a key in a particular K/V bucket Examples iex&gt; &quot;my_value&quot; = Jetstream.API.KV . get_value ( :gnat , &quot;my_bucket&quot; , &quot;my_key&quot; )","ref":"Gnat.Jetstream.API.KV.html#get_value/3"},{"type":"function","title":"Gnat.Jetstream.API.KV.is_kv_bucket_stream?/1","doc":"Returns true if the provided stream is a KV bucket, false otherwise Parameters stream_name - the stream name to test","ref":"Gnat.Jetstream.API.KV.html#is_kv_bucket_stream?/1"},{"type":"function","title":"Gnat.Jetstream.API.KV.list_buckets/1","doc":"Returns a list of all the buckets in the KV","ref":"Gnat.Jetstream.API.KV.html#list_buckets/1"},{"type":"function","title":"Gnat.Jetstream.API.KV.purge_key/4","doc":"Purge a Key from a K/V bucket. This will remove any revision history the key had Examples iex&gt; :ok = Jetstream.API.KV . purge_key ( :gnat , &quot;my_bucket&quot; , &quot;my_key&quot; )","ref":"Gnat.Jetstream.API.KV.html#purge_key/4"},{"type":"function","title":"Gnat.Jetstream.API.KV.put_value/5","doc":"Put a value into a Key in a K/V Bucket Examples iex&gt; :ok = Jetstream.API.KV . put_value ( :gnat , &quot;my_bucket&quot; , &quot;my_key&quot; , &quot;my_value&quot; )","ref":"Gnat.Jetstream.API.KV.html#put_value/5"},{"type":"function","title":"Gnat.Jetstream.API.KV.unwatch/1","doc":"Stops a previously running monitor. This will unsubscribe from the key changes and remove the ephemeral consumer Examples iex&gt; :ok = Jetstream.API.KV . unwatch ( pid )","ref":"Gnat.Jetstream.API.KV.html#unwatch/1"},{"type":"function","title":"Gnat.Jetstream.API.KV.watch/3","doc":"Starts a monitor for key changes in a given bucket. Supply a handler that will receive key change notifications. Examples iex&gt; { :ok , _pid } = Jetstream.API.KV . watch ( :gnat , &quot;my_bucket&quot; , fn action , key , value -&gt; IO . puts ( &quot; \#{ action } taken on \#{ key } &quot; ) end )","ref":"Gnat.Jetstream.API.KV.html#watch/3"},{"type":"type","title":"Gnat.Jetstream.API.KV.bucket_options/0","doc":"","ref":"Gnat.Jetstream.API.KV.html#t:bucket_options/0"},{"type":"module","title":"Gnat.Jetstream.API.KV.Watcher","doc":"The watcher server establishes a subscription to the changes that occur to a given key-value bucket. The consumer-supplied handler function will be sent an indicator as to whether the change is a delete or an add, as well as the key being changed and the value (if it was added). Ensure that you call stop with a watcher pid when you no longer need to be notified about key changes","ref":"Gnat.Jetstream.API.KV.Watcher.html"},{"type":"function","title":"Gnat.Jetstream.API.KV.Watcher.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Gnat.Jetstream.API.KV.Watcher.html#child_spec/1"},{"type":"function","title":"Gnat.Jetstream.API.KV.Watcher.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Gnat.Jetstream.API.KV.Watcher.html#init/1"},{"type":"function","title":"Gnat.Jetstream.API.KV.Watcher.start_link/1","doc":"","ref":"Gnat.Jetstream.API.KV.Watcher.html#start_link/1"},{"type":"function","title":"Gnat.Jetstream.API.KV.Watcher.stop/1","doc":"","ref":"Gnat.Jetstream.API.KV.Watcher.html#stop/1"},{"type":"type","title":"Gnat.Jetstream.API.KV.Watcher.keywatch_handler/0","doc":"","ref":"Gnat.Jetstream.API.KV.Watcher.html#t:keywatch_handler/0"},{"type":"type","title":"Gnat.Jetstream.API.KV.Watcher.watcher_options/0","doc":"","ref":"Gnat.Jetstream.API.KV.Watcher.html#t:watcher_options/0"},{"type":"module","title":"Gnat.Jetstream.API.Object","doc":"API for interacting with the JetStream Object Store Learn more about Object Store: https://docs.nats.io/nats-concepts/jetstream/obj_store","ref":"Gnat.Jetstream.API.Object.html"},{"type":"function","title":"Gnat.Jetstream.API.Object.create_bucket/3","doc":"","ref":"Gnat.Jetstream.API.Object.html#create_bucket/3"},{"type":"function","title":"Gnat.Jetstream.API.Object.delete/3","doc":"","ref":"Gnat.Jetstream.API.Object.html#delete/3"},{"type":"function","title":"Gnat.Jetstream.API.Object.delete_bucket/2","doc":"","ref":"Gnat.Jetstream.API.Object.html#delete_bucket/2"},{"type":"function","title":"Gnat.Jetstream.API.Object.get/4","doc":"","ref":"Gnat.Jetstream.API.Object.html#get/4"},{"type":"function","title":"Gnat.Jetstream.API.Object.info/3","doc":"","ref":"Gnat.Jetstream.API.Object.html#info/3"},{"type":"function","title":"Gnat.Jetstream.API.Object.list/3","doc":"","ref":"Gnat.Jetstream.API.Object.html#list/3"},{"type":"function","title":"Gnat.Jetstream.API.Object.put/4","doc":"","ref":"Gnat.Jetstream.API.Object.html#put/4"},{"type":"type","title":"Gnat.Jetstream.API.Object.bucket_opt/0","doc":"","ref":"Gnat.Jetstream.API.Object.html#t:bucket_opt/0"},{"type":"type","title":"Gnat.Jetstream.API.Object.list_option/0","doc":"","ref":"Gnat.Jetstream.API.Object.html#t:list_option/0"},{"type":"module","title":"Gnat.Jetstream.API.Object.Meta","doc":"","ref":"Gnat.Jetstream.API.Object.Meta.html"},{"type":"type","title":"Gnat.Jetstream.API.Object.Meta.t/0","doc":"","ref":"Gnat.Jetstream.API.Object.Meta.html#t:t/0"},{"type":"module","title":"Gnat.Jetstream.API.Stream","doc":"A module representing a NATS JetStream Stream. Learn more about Streams: https://docs.nats.io/nats-concepts/jetstream/streams The Jetstream.API.Stream struct The struct's mandatory fields are :name and :subjects . The rest will have the NATS default values set. Stream struct fields explanation: :allow_rollup_hdrs - allows the use of the Nats-Rollup header to replace all contents of a stream, or subject in a stream, with a single new message. :deny_delete - restricts the ability to delete messages from a stream via the API. Cannot be changed once set to true. :deny_purge - restricts the ability to purge messages from a stream via the API. Cannot be change once set to true. :description - a short description of the purpose of this stream. :discard - determines what happens when a Stream reaches its limits. It has the following options: :old - the default option. Old messages are deleted. :new - refuses new messages. :domain - JetStream domain, mainly used for leaf nodes. See JetStream on Leaf Nodes . :duplicate_window - the window within which to track duplicate messages, expressed in nanoseconds. :max_age - maximum age of any message in the Stream, expressed in nanoseconds. :max_bytes - how many bytes the Stream may contain. Adheres to :discard , removing oldest or refusing new messages if the Stream exceeds this size. :max_consumers - how many Consumers can be defined for a given Stream, -1 for unlimited. :max_msg_size - the largest message that will be accepted by the Stream. :max_msgs_per_subject - For wildcard streams ensure that for every unique subject this many messages are kept - a per subject retention limit. Only available on nats-server versions greater than 2.3.0 :max_msgs - how many messages may be in a Stream. Adheres to :discard , removing oldest or refusing new messages if the Stream exceeds this number of messages :mirror - maintains a 1:1 mirror of another stream with name matching this property. When a mirror is configured subjects and sources must be empty. :name - a name for the Stream. See naming . :no_ack - disables acknowledging messages that are received by the Stream. :num_replicas - how many replicas to keep for each message. :placement - placement directives to consider when placing replicas of this stream, random placement when unset. It has the following properties: :cluster - the desired cluster name to place the stream. :tags - tags required on servers hosting this stream. :retention - how messages are retained in the Stream. Once this is exceeded, old messages are removed. It has the following options: :limits - the default policy. :interest :workqueue :sealed - sealed streams do not allow messages to be deleted via limits or API, sealed streams can not be unsealed via configuration update. Can only be set on already created streams via the Update API. :sources - list of stream names to replicate into this stream. :storage - the type of storage backend. Available options: :file :memory :subjects - a list of subjects to consume, supports wildcards. :template_owner - when the Stream is managed by a Stream Template this identifies the template that manages the Stream.","ref":"Gnat.Jetstream.API.Stream.html"},{"type":"function","title":"Gnat.Jetstream.API.Stream.create/2","doc":"Creates a new Stream. Examples iex&gt; { :ok , %{ created : _ } } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;anewstream&quot; , subjects : [ &quot;anewsubject&quot; ] } )","ref":"Gnat.Jetstream.API.Stream.html#create/2"},{"type":"function","title":"Gnat.Jetstream.API.Stream.delete/3","doc":"Deletes a Stream and all its data. Examples iex&gt; Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;delstream&quot; , subjects : [ &quot;delsubject&quot; ] } ) iex&gt; Gnat.Jetstream.API.Stream . delete ( :gnat , &quot;delstream&quot; ) :ok iex&gt; { :error , %{ &quot;code&quot; =&gt; 404 , &quot;description&quot; =&gt; &quot;stream not found&quot; } } = Gnat.Jetstream.API.Stream . delete ( :gnat , &quot;wrong_stream&quot; )","ref":"Gnat.Jetstream.API.Stream.html#delete/3"},{"type":"function","title":"Gnat.Jetstream.API.Stream.get_message/4","doc":"Get a message from the stream either by &quot;stream sequence number&quot; or the &quot;last message for a given subject&quot;","ref":"Gnat.Jetstream.API.Stream.html#get_message/4"},{"type":"function","title":"Gnat.Jetstream.API.Stream.info/3","doc":"Information about config and state of a Stream. Examples iex&gt; { :ok , _ } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;infostream&quot; , subjects : [ &quot;infosubject&quot; ] } ) iex&gt; { :ok , %{ created : _ } } = Gnat.Jetstream.API.Stream . info ( :gnat , &quot;infostream&quot; ) iex&gt; { :error , %{ &quot;code&quot; =&gt; 404 , &quot;description&quot; =&gt; &quot;stream not found&quot; } } = Gnat.Jetstream.API.Stream . info ( :gnat , &quot;wrong_stream&quot; )","ref":"Gnat.Jetstream.API.Stream.html#info/3"},{"type":"function","title":"Gnat.Jetstream.API.Stream.list/2","doc":"Paged list of known Streams including all their current information. Options :offset - Number of records to skip :subject - A subject the Stream must collect to appear in the list. Examples iex&gt; { :ok , %{ total : _ , offset : 0 , limit : 1024 , streams : _ } } = Gnat.Jetstream.API.Stream . list ( :gnat )","ref":"Gnat.Jetstream.API.Stream.html#list/2"},{"type":"function","title":"Gnat.Jetstream.API.Stream.purge/3","doc":"Purges all of data in the stream but doesn't delete the stream. Examples iex&gt; Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;purgestream&quot; , subjects : [ &quot;purgesubject&quot; ] } ) iex&gt; Gnat.Jetstream.API.Stream . purge ( :gnat , &quot;purgestream&quot; ) :ok iex&gt; { :error , %{ &quot;code&quot; =&gt; 404 , &quot;description&quot; =&gt; &quot;stream not found&quot; } } = Gnat.Jetstream.API.Stream . purge ( :gnat , &quot;wrong_stream&quot; )","ref":"Gnat.Jetstream.API.Stream.html#purge/3"},{"type":"function","title":"Gnat.Jetstream.API.Stream.purge/4","doc":"Purges some of the messages in a stream according to the supplied filter Examples iex&gt; Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;pstream&quot; , subjects : [ &quot;psub1&quot; , &quot;psub2&quot; ] } ) iex&gt; Gnat.Jetstream.API.Stream . purge ( :gnat , &quot;pstream&quot; , nil , %{ filter : &quot;psub1&quot; } ) :ok","ref":"Gnat.Jetstream.API.Stream.html#purge/4"},{"type":"function","title":"Gnat.Jetstream.API.Stream.update/2","doc":"Updates a Stream. Examples iex&gt; { :ok , %{ created : _ } } = Gnat.Jetstream.API.Stream . create ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;update_test_stream&quot; , subjects : [ &quot;update_subject&quot; ] } ) iex&gt; { :ok , _ } = Gnat.Jetstream.API.Stream . update ( :gnat , % Gnat.Jetstream.API.Stream { name : &quot;update_test_stream&quot; , subjects : [ &quot;update_subject&quot; , &quot;new.update_subject&quot; ] } )","ref":"Gnat.Jetstream.API.Stream.html#update/2"},{"type":"type","title":"Gnat.Jetstream.API.Stream.info/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:info/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.message_access_method/0","doc":"seq - Stream sequence number of the message to retrieve, cannot be combined with last_by_subj last_by_subj - Retrieves the last message for a given subject, cannot be combined with seq","ref":"Gnat.Jetstream.API.Stream.html#t:message_access_method/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.message_response/0","doc":"data - The decoded message payload subject - The subject the message was originally received on time - The time the message was received seq - The sequence number of the message in the Stream hdrs - The decoded headers for the message","ref":"Gnat.Jetstream.API.Stream.html#t:message_response/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.method/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:method/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.nanoseconds/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:nanoseconds/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.placement/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:placement/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.response_error/0","doc":"code - HTTP like error code in the 300 to 500 range description - A human friendly description of the error err_code - The NATS error code unique to each kind of error","ref":"Gnat.Jetstream.API.Stream.html#t:response_error/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.source/0","doc":"Stream source fields explained: :name - stream name. :opt_start_seq - sequence to start replicating from. :opt_start_time - timestamp to start replicating from. :filter_subject - replicate only a subset of messages based on filter. :external - configuration referencing a stream source in another account or JetStream domain. It has the following parameters: :api - the subject prefix that imports other account/domain $JS.API.CONSUMER.&gt; subjects :deliver - the delivery subject to use for push consumer","ref":"Gnat.Jetstream.API.Stream.html#t:source/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.source_info/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:source_info/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.state/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:state/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.streams/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:streams/0"},{"type":"type","title":"Gnat.Jetstream.API.Stream.t/0","doc":"","ref":"Gnat.Jetstream.API.Stream.html#t:t/0"},{"type":"behaviour","title":"Gnat.Jetstream.PullConsumer","doc":"A behaviour which provides the NATS JetStream Pull Consumer functionalities. When a Consumer is pull-based, it means that the messages will be delivered when the server is asked for them. Example Declare a module which uses Gnat.Jetstream.PullConsumer and implements init/1 and handle_message/2 callbacks. defmodule MyApp.PullConsumer do use Gnat.Jetstream.PullConsumer def start_link ( arg ) do Jetstream.PullConsumer . start_link ( __MODULE__ , arg ) end @impl true def init ( _arg ) do { :ok , nil , connection_name : :gnat , stream_name : &quot;TEST_STREAM&quot; , consumer_name : &quot;TEST_CONSUMER&quot; } end @impl true def handle_message ( message , state ) do # Do some processing with the message. { :ack , state } end end You can then place your Pull Consumer in a supervision tree. Remember that you need to have the Gnat.ConnectionSupervisor set up. defmodule MyApp.Application do use Application @impl true def start ( _type , _args ) do children = [ # Create NATS connection { Gnat.ConnectionSupervisor , ... } , # Start NATS Jetstream Pull Consumer MyApp.PullConsumer , ] opts = [ strategy : :one_for_one ] Supervisor . start_link ( children , opts ) end end Connection Options In order to establish consumer connection with NATS, you need to pass several connection options via keyword list in third element of a tuple returned from init/1 callback. Following options must be provided. Omitting this options will cause the process to raise errors upon initialization: :connection_name - Gnat connection or Gnat.ConnectionSupervisor name/PID. :stream_name - name of an existing string the consumer will consume messages from. :consumer_name - name of an existing consumer pointing at the stream. You can also pass the optional ones: :connection_retry_timeout - a duration in milliseconds after which the PullConsumer which failed to establish NATS connection retries, defaults to 1000 :connection_retries - a number of attempts the PullConsumer will make to establish the NATS connection. When this value is exceeded, the pull consumer stops with the :timeout reason, defaults to 10 :inbox_prefix - allows the default _INBOX. prefix to be customized. Should end with a dot. :domain - use a JetStream domain, this is mostly used on leaf nodes. Dynamic Connection Options It is possible that you have to determine some of the options dynamically depending on pull consumer's init argument. To do so, it is recommended to derive these options values from some init argument: defmodule MyApp.PullConsumer do use Gnat.Jetstream.PullConsumer def start_link ( ) do Gnat.Jetstream.PullConsumer . start_link ( __MODULE__ , %{ counter : counter } ) end @impl true def init ( %{ counter : counter } ) do { :ok , nil , connection_name : :gnat , stream_name : &quot;TEST_STREAM_ \#{ counter } &quot; , consumer_name : &quot;TEST_CONSUMER_ \#{ counter } &quot; } end ... end How to supervise A PullConsumer is most commonly started under a supervision tree. When we invoke use Gnat.Jetstream.PullConsumer , it automatically defines a child_spec/1 function that allows us to start the pull consumer directly under a supervisor. To start a pull consumer under a supervisor with an initial argument of :example, one may do: children = [ { MyPullConsumer , :example } ] Supervisor . start_link ( children , strategy : :one_for_all ) While one could also simply pass the MyPullConsumer as a child to the supervisor, such as: children = [ MyPullConsumer # Same as {MyPullConsumer, []} ] Supervisor . start_link ( children , strategy : :one_for_all ) A common approach is to use a keyword list, which allows setting init argument and server options, for example: def start_link ( opts ) do { initial_state , opts } = Keyword . pop ( opts , :initial_state , nil ) Gnat.Jetstream.PullConsumer . start_link ( __MODULE__ , initial_state , opts ) end and then you can use MyPullConsumer , {MyPullConsumer, name: :my_consumer} or even {MyPullConsumer, initial_state: :example, name: :my_consumer} as a child specification. use Gnat.Jetstream.PullConsumer also accepts a list of options which configures the child specification and therefore how it runs under a supervisor. The generated child_spec/1 can be customized with the following options: :id - the child specification identifier, defaults to the current module :restart - when the child should be restarted, defaults to :permanent :shutdown - how to shut down the child, either immediately or by giving it time to shut down For example: use Gnat.Jetstream.PullConsumer , restart : :transient , shutdown : 10_000 See the &quot;Child specification&quot; section in the Supervisor module for more detailed information. The @doc annotation immediately preceding use Jetstream.PullConsumer will be attached to the generated child_spec/1 function. Name registration A pull consumer is bound to the same name registration rules as GenServers. Read more about it in the GenServer documentation.","ref":"Gnat.Jetstream.PullConsumer.html"},{"type":"function","title":"Gnat.Jetstream.PullConsumer.close/1","doc":"Closes the pull consumer and stops underlying process. Example { :ok , consumer } = PullConsumer . start_link ( ExamplePullConsumer , connection_name : :gnat , stream_name : &quot;TEST_STREAM&quot; , consumer_name : &quot;TEST_CONSUMER&quot; ) :ok = PullConsumer . close ( consumer )","ref":"Gnat.Jetstream.PullConsumer.html#close/1"},{"type":"callback","title":"Gnat.Jetstream.PullConsumer.handle_message/2","doc":"Invoked to synchronously process a message pulled by the consumer. Depending on the value it returns, the acknowledgement is or is not sent. ACK actions Possible ACK actions values explained: :ack - acknowledges the message was handled and requests delivery of the next message to the reply subject. :nack - signals that the message will not be processed now and processing can move onto the next message, NAK'd message will be retried. :term - instructs the server to stop redelivery of a message without acknowledging it as successfully processed. :noreply - nothing is sent. You may send later asynchronously an ACK or NACK message using the Jetstream.ack/1 or Jetstream.nack/1 and similar functions from Jetstream module. Example def handle_message ( message , state ) do IO . inspect ( message ) { :ack , state } end","ref":"Gnat.Jetstream.PullConsumer.html#c:handle_message/2"},{"type":"callback","title":"Gnat.Jetstream.PullConsumer.init/1","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3 . See Connection.init/1 for more details.","ref":"Gnat.Jetstream.PullConsumer.html#c:init/1"},{"type":"function","title":"Gnat.Jetstream.PullConsumer.start/3","doc":"Starts a Jetstream.PullConsumer process without links (outside of a supervision tree). See start_link/3 for more information.","ref":"Gnat.Jetstream.PullConsumer.html#start/3"},{"type":"function","title":"Gnat.Jetstream.PullConsumer.start_link/3","doc":"Starts a pull consumer linked to the current process with the given function. This is often used to start the pull consumer as part of a supervision tree. Once the server is started, the init/1 function of the given module is called with init_arg as its argument to initialize the server. To ensure a synchronized start-up procedure, this function does not return until init/1 has returned. See GenServer.start_link/3 for more details.","ref":"Gnat.Jetstream.PullConsumer.html#start_link/3"},{"type":"type","title":"Gnat.Jetstream.PullConsumer.connection_option/0","doc":"Connection option values used to connect the consumer to NATS server.","ref":"Gnat.Jetstream.PullConsumer.html#t:connection_option/0"},{"type":"type","title":"Gnat.Jetstream.PullConsumer.connection_options/0","doc":"Connection options used to connect the consumer to NATS server.","ref":"Gnat.Jetstream.PullConsumer.html#t:connection_options/0"},{"type":"type","title":"Gnat.Jetstream.PullConsumer.consumer/0","doc":"The pull consumer reference.","ref":"Gnat.Jetstream.PullConsumer.html#t:consumer/0"},{"type":"behaviour","title":"Gnat.Server","doc":"A behavior for acting as a server for nats messages. You can use this behavior in your own module and then use the Gnat.ConsumerSupervisor to listen for and respond to nats messages. Example defmodule MyApp.RpcServer do use Gnat.Server def request ( %{ body : _body } ) do { :reply , &quot;hi&quot; } end # defining an error handler is optional, the default one will just call Logger.error for you def error ( %{ gnat : gnat , reply_to : reply_to } , _error ) do Gnat . pub ( gnat , reply_to , &quot;Something went wrong and I can&#39;t handle your request&quot; ) end end","ref":"Gnat.Server.html"},{"type":"callback","title":"Gnat.Server.error/2","doc":"Called when an error occured during the request/1 If your request/1 function returned {:error, term} , then the term you returned will be passed as the second argument. If an exception was raised during your request/1 function, then the exception will be passed as the second argument. If your request/1 function returned something other than the supported return types, then its return value will be passed as the second argument.","ref":"Gnat.Server.html#c:error/2"},{"type":"callback","title":"Gnat.Server.request/1","doc":"Called when a message is received from the broker","ref":"Gnat.Server.html#c:request/1"},{"type":"behaviour","title":"Gnat.Services.Server","doc":"A behavior for acting as a NATS service Creating a service with this behavior works almost exactly the same as Gnat.Server , with the bonus that this service keeps track of requests, errors, processing time, and participates in service discovery and monitoring as defined by the NATS service protocol . Example defmodule MyApp.Service do use Gnat.Services.Server # Classic subject matching def request ( %{ body : _body , topic : &quot;myservice.req&quot; } , _ , _ ) do { :reply , &quot;handled request&quot; } end # Can also match on endpoint or group def request ( msg , &quot;add&quot; , &quot;calculator&quot; ) do { :reply , &quot;42&quot; } end # defining an error handler is optional, the default one will just call Logger.error for you def error ( %{ gnat : gnat , reply_to : reply_to } , _error ) do Gnat . pub ( gnat , reply_to , &quot;Something went wrong and I can&#39;t handle your request&quot; ) end end","ref":"Gnat.Services.Server.html"},{"type":"callback","title":"Gnat.Services.Server.error/2","doc":"Called when an error occured during the request/1 . Automatically increments the error count and processing time stats for this service. If your request/1 function returned {:error, term} , then the term you returned will be passed as the second argument. If an exception was raised during your request/1 function, then the exception will be passed as the second argument. If your request/1 function returned something other than the supported return types, then its return value will be passed as the second argument.","ref":"Gnat.Services.Server.html#c:error/2"},{"type":"callback","title":"Gnat.Services.Server.request/3","doc":"Called when a message is received from the broker. The endpoint on which the message arrived is always supplied. If the endpoint is a member of a group, the group name will also be provided. Automatically increments the request time and processing time stats for this service.","ref":"Gnat.Services.Server.html#c:request/3"},{"type":"type","title":"Gnat.Services.Server.endpoint_configuration/0","doc":"Each service configuration must contain at least one endpoint. Endpoints can manually specify their subscription subjects or they can be derived from the endpoint name. subject - A specific subject for this endpoint to listen on. If this is not provided, then the endpoint name will be used. name - The required name of the endpoint group_name - An optional group to which this endpoint belongs queue_group - A queue group for this endpoint's subscription. If not supplied, &quot;q&quot; will be used (indicated by protocol spec). metadata - An optional string-&gt;string map containing metadata for this endpoint","ref":"Gnat.Services.Server.html#t:endpoint_configuration/0"},{"type":"type","title":"Gnat.Services.Server.service_configuration/0","doc":"Service configuration is provided as part of the consumer supervisor settings in the service_definition field. You can specify either the subscription_topics field for a regluar server or the service_definition field for a new NATS service. name - The name of the service. Needs to conform to the rules for NATS service names version - A required version number (w/out &quot;v&quot; prefix) conforming to semver rules queue_group - An optional queue group for service subscriptions. If left off, &quot;q&quot; will be used. description - An optional description of the service metadata - An optional string-&gt;string map of service metadata endpoints - A required list of service endpoints. All services must have at least one endpoint","ref":"Gnat.Services.Server.html#t:service_configuration/0"},{"type":"extras","title":"README","doc":"Gnat A nats.io client for Elixir. The goals of the project are resiliency, performance, and ease of use. Hex documentation available here: https://hex.pm/packages/gnat","ref":"readme.html"},{"type":"extras","title":"README - Usage","doc":"{ :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 } ) # Or if the server requires TLS you can start a connection with: # {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, tls: true}) { :ok , subscription } = Gnat . sub ( gnat , self ( ) , &quot;pawnee.*&quot; ) :ok = Gnat . pub ( gnat , &quot;pawnee.news&quot; , &quot;Leslie Knope recalled from city council (Jammed)&quot; ) receive do { :msg , %{ body : body , topic : &quot;pawnee.news&quot; , reply_to : nil } } -&gt; IO . puts ( body ) end","ref":"readme.html#usage"},{"type":"extras","title":"README - Authentication","doc":"# with user and password { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , username : &quot;joe&quot; , password : &quot;123&quot; , auth_required : true } ) # with token { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , token : &quot;secret&quot; , auth_required : true } ) # with an nkey seed { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , nkey_seed : &quot;SUAM...&quot; , auth_required : true } ) # with decentralized user credentials (JWT) { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , nkey_seed : &quot;SUAM...&quot; , jwt : &quot;eyJ0eX...&quot; , auth_required : true } ) # connect to NGS with JWT { :ok , gnat } = Gnat . start_link ( %{ host : &quot;connect.ngs.global&quot; , tls : true , jwt : &quot;ey...&quot; , nkey_seed : &quot;SUAM...&quot; } )","ref":"readme.html#authentication"},{"type":"extras","title":"README - TLS Connections","doc":"NATS Server is often configured to accept or require TLS connections. In order to connect to these clusters you'll want to pass some extra TLS settings to your Gnat connection. # using a basic TLS connection { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , tls : true } ) # Passing a Client Certificate for verification { :ok , gnat } = Gnat . start_link ( %{ tls : true , ssl_opts : [ certfile : &quot;client-cert.pem&quot; , keyfile : &quot;client-key.pem&quot; ] } )","ref":"readme.html#tls-connections"},{"type":"extras","title":"README - Resiliency","doc":"If you would like to stay connected to a cluster of nats servers, you should consider using Gnat.ConnectionSupervisor . This can be added to your supervision tree in your project and will handle automatically re-connecting to the cluster. For long-lived subscriptions consider using Gnat.ConsumerSupervisor . This can also be added to your supervision tree and use a supervised connection to re-establish a subscription. It also handles details like handling each message in a supervised process so you isolate failures and get OTP logs when an unexpected error occurs.","ref":"readme.html#resiliency"},{"type":"extras","title":"README - Services","doc":"If you supply a module that implements the Gnat.Services.Server behavior and the service_definition configuration field to a Gnat.ConsumerSupervisor , then this client will automatically take care of exposing the service to discovery, responding to pings, and maintaining and exposing statistics like request and error counts, and processing times.","ref":"readme.html#services"},{"type":"extras","title":"README - Instrumentation","doc":"Gnat uses telemetry to make instrumentation data available to clients. If you want to record metrics around the number of messages or latency of message publishes, subscribes, requests, etc you can do the following in your project: iex(1)&gt; metrics_function = fn ( event_name , measurements , event_meta , config ) -&gt; IO . inspect ( [ event_name , measurements , event_meta , config ] ) :ok end # Function &lt; 4.128620087 / 4 in :erl_eval . expr / 5 &gt; iex(2)&gt; names = [ [ :gnat , :pub ] , [ :gnat , :sub ] , [ :gnat , :message_received ] , [ :gnat , :request ] , [ :gnat , :unsub ] ] [ [ :gnat , :pub ] , [ :gnat , :sub ] , [ :gnat , :message_received ] , [ :gnat , :request ] , [ :gnat , :unsub ] , [ :gnat , :service_request ] , [ :gnat , :service_error ] ] iex(3)&gt; :telemetry . attach_many ( &quot;my listener&quot; , names , metrics_function , %{ my_config : true } ) :ok iex(4)&gt; { :ok , gnat } = Gnat . start_link ( ) { :ok , # PID &lt; 0 . 203 . 0 &gt; } iex(5)&gt; Gnat . sub ( gnat , self ( ) , &quot;topic&quot; ) [ [ :gnat , :sub ] , %{ latency : 128000 } , %{ topic : &quot;topic&quot; } , %{ my_config : true } ] { :ok , 1 } iex(6)&gt; Gnat . pub ( gnat , &quot;topic&quot; , &quot;ohai&quot; ) [ [ :gnat , :pub ] , %{ latency : 117000 } , %{ topic : &quot;topic&quot; } , %{ my_config : true } ] [ [ :gnat , :message_received ] , %{ count : 1 } , %{ topic : &quot;topic&quot; } , %{ my_config : true } ] :ok The pub , sub , request , and unsub events all report the latency of those respective calls. The message_received event reports a number of messages like %{count: 1} because there isn't a good latency metric to report. Any microservices managed by a consumer supervisor will also report service_request and service_error . In addition to the :topic metadata, microservices will also include :endpoint and :group (which can be nil ) in their telemetry reports. All of the events (except unsub ) include metadata with a :topic key so you can split your metrics by topic.","ref":"readme.html#instrumentation"},{"type":"extras","title":"README - Benchmarks","doc":"Part of the motivation for building this library is to get better performance. To this end, there is a bench branch on this project which includes a server.exs and client.exs that can be used for benchmarking various scenarios. As of this commit, the latest benchmark on a 16-core server shows that you can make 170k+ req/sec or up to 192MB/sec. The bench/*.exs files also contain some straight-line single-CPU performance tests. As of this commit my 2018 MacBook pro shows. ips average deviation median parse-128 487.67 K 2.19 μs ±1701.54% 2 μs pub - 128 96.37 K 10.38 μs ±102.94% 10 μs req-reply-128 8.32 K 120.16 μs ±23.68% 114 μs","ref":"readme.html#benchmarks"},{"type":"extras","title":"README - Development","doc":"Before running the tests make sure you have a locally running copy of nats-server ( installation instructions ). We currently use version 2.6.6 in CI, but anything higher than 2.2.0 should be fine. Versions from 0.9.6 up to 2.2.0 should work fine for everything except header support. The typical mix test will run all the basic unit tests. You can also run the multi_server set of tests that test connectivity to different nats-server configurations. You can run these with mix test --only multi_server . The tests will tell you how to start the different configurations. There are also some property-based tests that generate a lot of test cases. You can tune how many test cases by setting the environment variable N=200 mix test --only property (default it 100). For more details you can look at how Travis runs these things in the CI flow.","ref":"readme.html#development"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - 1.8","doc":"Integrated the jetstream functionality into this client directly https://github.com/nats-io/nats.ex/pull/146 Add ability to list KV buckets https://github.com/nats-io/nats.ex/pull/152 Improve CI Reliability https://github.com/nats-io/nats.ex/pull/154 Bugfix to treat no streams as an empty list rather than a null https://github.com/nats-io/nats.ex/pull/155","ref":"changelog.html#1-8"},{"type":"extras","title":"Changelog - 1.7","doc":"Added support for the NATS services API , letting developers participate in service discovery and stats https://github.com/nats-io/nats.ex/pull/141 A bugfix to remove the queue_group from a service config and some optimization for the services API https://github.com/nats-io/nats.ex/pull/145","ref":"changelog.html#1-7"},{"type":"extras","title":"Changelog - 1.6","doc":"added the no_responders behavior https://github.com/nats-io/nats.ex/pull/137","ref":"changelog.html#1-6"},{"type":"extras","title":"Changelog - 1.5","doc":"add the inbox_prefix option https://github.com/nats-io/nats.ex/pull/121 add the Gnat.server_info/1 function https://github.com/nats-io/nats.ex/pull/124 fix header parsing issue https://github.com/nats-io/nats.ex/pull/125","ref":"changelog.html#1-5"},{"type":"extras","title":"Changelog - 1.4","doc":"add the Gnat.request_multi/4 function https://github.com/nats-io/nats.ex/pull/120 add elixir 1.13 to the test matrix","ref":"changelog.html#1-4"},{"type":"extras","title":"Changelog - 1.3","doc":"adding support for sending and receiving headers https://github.com/nats-io/nats.ex/pull/116","ref":"changelog.html#1-3"},{"type":"extras","title":"Changelog - 1.2","doc":"Gnat.Server behaviour with support in the ConsumerSupervisor https://github.com/nats-io/nats.ex/compare/1b1adc85e4b28231218ef87c7fc3445fce854377...b24a7e14325b51fbb93fde7e3d891d18b4fa8afb avoid logging sensitive credentials https://github.com/nats-io/nats.ex/pull/105 deprecate Gnat.ping, improved typespecs https://github.com/nats-io/nats.ex/pull/103 relax the version constraint on nimble_parsec https://github.com/nats-io/nats.ex/issues/112","ref":"changelog.html#1-2"},{"type":"extras","title":"Changelog - 1.1","doc":"add support for nkeys and NGS https://github.com/nats-io/nats.ex/pull/101 Fix supervisor ConsumerSuperivsor crash https://github.com/nats-io/nats.ex/pull/96","ref":"changelog.html#1-1"},{"type":"extras","title":"Changelog - 1.0","doc":"Make supervisors officially supported https://github.com/nats-io/nats.ex/pull/96","ref":"changelog.html#1-0"},{"type":"extras","title":"Changelog - 0.7.0","doc":"update to telemetry 0.4 https://github.com/nats-io/nats.ex/pull/86 and https://github.com/nats-io/nats.ex/pull/87 support for token authentication https://github.com/nats-io/nats.ex/pull/92 support elixir 1.9 https://github.com/nats-io/nats.ex/pull/93","ref":"changelog.html#0-7-0"},{"type":"extras","title":"Changelog - 0.6.0","doc":"Dropped support for Erlang &lt; 19 and Elixir &lt;= 1.5 Added Telemetry to the project (thanks @rubysolo) Switched to nimble_parsec for parsing Updated benchmarking/performance information. We can now do 170k requests per second on a 16-core server. Fixed a bug around re-subscribing for the ConsumerSupervisor Pass sid when delivering message (thanks @entone) Documentation fixes from @deini and @johannestroeger","ref":"changelog.html#0-6-0"},{"type":"extras","title":"Changelog - 0.5.0","doc":"Dropped support for Elixir 1.4 and OTP 18 releases. You will need to use Elixir 1.5+ and OTP 19+. Switched to running our tests against gnatsd 1.3.0","ref":"changelog.html#0-5-0"},{"type":"extras","title":"Overview","doc":"Jetstream is a distributed persistence system built-in to NATS . It provides a streaming system that lets you capture streams of events from various sources and persist these into persistent stores, which you can immediately or later replay for processing. This library exposes interfaces for publishing, consuming and managing Jetstream services. It builds on top of Gnat , the officially supported Elixir client for NATS. Let's get Jetstream up and running Using Broadway with Jetstream Pull Consumer API Create, update and delete Jetstream streams and consumers via Elixir","ref":"overview.html"},{"type":"extras","title":"Getting Started","doc":"In this guide, we're going to learn how to install Jetstream in your project and start consuming messages from your streams.","ref":"getting_started.html"},{"type":"extras","title":"Getting Started - Starting Jetstream","doc":"The following Docker Compose file will do the job: version: &quot;3&quot; services: nats: image: nats:latest command: - -js ports: - 4222:4222 Save this snippet as docker-compose.yml and run the following command: docker compose up -d Let's also create Jetstream stream where we will publish our hello world messages: nats stream add HELLO --subjects=&quot;greetings&quot; Tip You can also manage Jetstream streams and consumers via Elixir. You can see more details in this guide .","ref":"getting_started.html#starting-jetstream"},{"type":"extras","title":"Getting Started - Adding Jetstream and Gnat to an application","doc":"To start off with, we'll generate a new Elixir application by running this command: mix new hello_jetstream -- sup We need to have a supervision tree up and running in your app, and the --sup option ensures that. To add Jetstream to this application, you need to add Jetstream and Gnat libraries to your deps definition in our mix.exs file. Fill exact version requirements from each package Hex.pm pages. defp deps do [ { :gnat , ... } , { :jetstream , ... } ] end To install these dependencies, we will run this command: mix deps.get Now let's connect to our NATS server. To do this, you need to start Gnat.ConnectionSupervisor under our application's supervision tree. Add following to lib/hello_jetstream/application.ex : def start ( _type , _args ) do children = [ ... # Create NATS connection { Gnat.ConnectionSupervisor , %{ name : :gnat , connection_settings : [ %{ host : &quot;localhost&quot; , port : 4222 } ] } } , ] ... This piece of configuration will start Gnat processes that connect to the NATS server and allow publishing and subscribing to any subjects. Jetstream operates using plain NATS subjects which follow specific naming and message format conventions. Let's now create a pull consumer which will subscribe a specific Jetstream stream and print incoming messages to standard output.","ref":"getting_started.html#adding-jetstream-and-gnat-to-an-application"},{"type":"extras","title":"Getting Started - Creating a pull consumer","doc":"Jetstream requires us to allocate a view/cursor of the stream that our consumer will operate on. In Jetstream terminology, this view is called a consumer (Funnily enough we've just implemented a consumer in our code, coincidence?). Jetstream documentation offers great insights on benefits of having this separate concept so we won't duplicate work here. Jetstream offers two stream consuming modes: push and pull . In push mode, Jetstream will simply send messages to selected consumers immediately when they are received. This approach does offer congestion control, so it is not recommended for high-volume and/or reliability sensitive streams. You do not really need this library to implement push consumer because all building blocks are in Gnat library. You can read more about push consumers in this guide . On the other hand, in pull mode consumers ask Jetstream for more messages when they are ready to process them. This is the recommended approach for most use cases and we will proceed with it in this guide. This is just a brief outline For more details about differences between consumer modes, consult Jetstream documentation . Let's create a pull consumer module within our application at lib/hello_jetstream/logger_pull_consumer.ex : defmodule HelloJetstream.LoggerPullConsumer do use Jetstream.PullConsumer def start_link ( [ ] ) do Jetstream.PullConsumer . start_link ( __MODULE__ , [ ] ) end @impl true def init ( [ ] ) do { :ok , nil , connection_name : :gnat , stream_name : &quot;HELLO&quot; , consumer_name : &quot;LOGGER&quot; } end @impl true def handle_message ( message , state ) do IO . inspect ( message ) { :ack , state } end end Pull Consumer is a regular GenServer and it takes a reference to Gnat.ConnectionSupervisor along with names of Jetstream stream and consumer as options passed to Jetstream.PullConsumer.start* functions. These options are passed as keyword list in third element of tuple returned from the c:Jetstream.PullConsumer.init/1 callback. The only required callbacks are well known gen server's c:Jetstream.PullConsumer.init/1 and c:Jetstream.PullConsumer.handle_message/2 , which takes new message as its first argument and is expected to return an ACK action instructing underlying process loop what to do with this message. Here we are asking it to automatically send for us an ACK message back to Jetstream. Let's now create a consumer in our NATS server. We will call it LOGGER as we plan to let it simply log everything published to the stream. nats consumer add --pull --deliver=all HELLO LOGGER Now, let's start our pull consumer under application's supervision tree. def start ( _type , _args ) do children = [ ... # Jetstream Pull Consumer HelloJetstream.LoggerPullConsumer , ] ... Let's now publish some messages to our HELLO stream, so something will be waiting for our application to be read when it starts.","ref":"getting_started.html#creating-a-pull-consumer"},{"type":"extras","title":"Getting Started - Publishing messages to streams","doc":"Jetstream listens on regular NATS subjects, so publishing messages is dead simple with Gnat.pub/3 : Gnat . pub ( :gnat , &quot;greetings&quot; , &quot;Hello World&quot; ) Or via NATS CLI: nats pub greetings &quot;Hello World&quot; That's it! When you run your app, you should see your messages being read by your application.","ref":"getting_started.html#publishing-messages-to-streams"},{"type":"extras","title":"Managing Streams and Consumers","doc":"Jetstream provides a JSON API for managing streams and consumers. This library exposes this API via interactions with the Jetstream.Api.Stream and Jetstream.Api.Consumer modules. These modules act as native wrappers for the API and do not attempt to simplify any of the common use-cases. As this library matures we may introduce a separate layer of functions to handle these scenarios, but for now our aim is to provide full access to the Jetstream API.","ref":"managing.html"},{"type":"extras","title":"Push based consumer","doc":"# Start a nats server with jetstream enabled and default configs # Now run the following snippets in an IEx terminal alias Jetstream.API . { Consumer , Stream } # Setup a connection to the nats server and create the stream/consumer # This is the equivalent of these two nats cli commands # nats stream add TEST --subjects=&quot;greetings&quot; --max-msgs=-1 --max-msg-size=-1 --max-bytes=-1 --max-age=-1 --storage=file --retention=limits --discard=old # nats consumer add TEST TEST --target consumer.greetings --replay instant --deliver=all --ack all --wait=5s --filter=&quot;&quot; --max-deliver=10 { :ok , connection } = Gnat . start_link ( ) stream = % Stream { name : &quot;TEST&quot; , subjects : [ &quot;greetings&quot; ] } { :ok , _response } = Stream . create ( connection , stream ) consumer = % Consumer { stream_name : &quot;TEST&quot; , name : &quot;TEST&quot; , deliver_subject : &quot;consumer.greetings&quot; , ack_wait : 5_000_000_000 , max_deliver : 10 } { :ok , _response } = Consumer . create ( connection , consumer ) # Setup Consuming Function defmodule Subscriber do def handle ( msg ) do IO . inspect ( msg ) case msg . body do &quot;hola&quot; -&gt; Jetstream . ack ( msg ) &quot;bom dia&quot; -&gt; Jetstream . nack ( msg ) _ -&gt; nil end end end # normally you would add the `ConnectionSupervisor` and `ConsumerSupervisor` to your supervisrion tree # here we start them up manually in an IEx session { :ok , _pid } = Gnat.ConnectionSupervisor . start_link ( %{ name : :gnat , backoff_period : 4_000 , connection_settings : [ %{ } ] } ) { :ok , _pid } = Gnat.ConsumerSupervisor . start_link ( %{ connection_name : :gnat , consuming_function : { Subscriber , :handle } , subscription_topics : [ %{ topic : &quot;consumer.greetings&quot; } ] } ) # now publish some messages into the stream Gnat . pub ( :gnat , &quot;greetings&quot; , &quot;hello&quot; ) # no ack will be sent back, so you&#39;ll see this message received 10 times with a 5sec pause between each one Gnat . pub ( :gnat , &quot;greetings&quot; , &quot;hola&quot; ) # an ack is sent back so this will only be received once Gnat . pub ( :gnat , &quot;greetings&quot; , &quot;bom dia&quot; ) # a -NAK is sent back so you&#39;ll see this received 10 times very quickly","ref":"push_based_consumer.html"},{"type":"extras","title":"Using Broadway with Jetstream","doc":"Broadway is a library which allows building concurrent and multi-stage data ingestion and data processing pipelines with Elixir easily. You can learn about it more in Broadway documentation . Jetstream library comes with tools necessary to use NATS Jetstream with Broadway.","ref":"broadway.html"},{"type":"extras","title":"Using Broadway with Jetstream - Getting started","doc":"In order to use Broadway with NATS Jetstream you need to: Setup a NATS Server with JetStream turned on Create stream and consumer on NATS server Configure Gnat connection in your Elixir project Configure your project to use Broadway In this guide, we are going to focus on the fourth point. To learn how to start Jetstream locally with Docker Compose and then add Gnat and Jetstream to your application, see the Starting Jetstream section in Getting Started guide . Adding Broadway to your application Once we have NATS with JetStream running and the stream and consumer we are going to use are created, we can proceed to adding Broadway to our project. First, put :broadway to the list of dependencies in mix.exs . defp deps do [ ... { :broadway , ... version ... } , ... ] end Visit Broadway page on Hex.pm to check for current version to put in deps . To install the dependencies, run: mix deps.get Defining the pipeline configuration The next step is to define your Broadway module. We need to implement three functions in order to define a Broadway pipeline: start_link/1 , handle_message/3 and handle_batch/4 . Let's create start_link/1 first: defmodule MyBroadway do use Broadway alias Broadway.Message def start_link ( _opts ) do Broadway . start_link ( __MODULE__ , name : MyBroadwayExample , producer : [ module : { OffBroadway.Jetstream.Producer , connection_name : :gnat , stream_name : &quot;TEST_STREAM&quot; , consumer_name : &quot;TEST_CONSUMER&quot; } , concurrency : 10 ] , processors : [ default : [ concurrency : 10 ] ] , batchers : [ default : [ concurrency : 5 , batch_size : 10 , batch_timeout : 2_000 ] ] ... ) end ... callbacks .. end All start_link/1 does is just delegating to Broadway.start_link/2 . To understand what all these options mean and to learn about other possible settings, visit Broadway documentation . The part that interests us the most in this guide is the producer.module . Here we're choosing OffBroadway.Jetstream.Producer as the producer module and passing the connection options, such as Gnat process name and stream name. For full list of available options, visit Producer documentation. Implementing Broadway callbacks Broadway requires some callbacks to be implemented in order to process messages. For full list of available callbacks visit Broadway documentation . A simple example: defmodule MyBroadway do use Broadway alias Broadway.Message ... start_link ... def handle_message ( _processor_name , message , _context ) do message |&gt; Message . update_data ( &amp; process_data / 1 ) |&gt; case do &quot;FOO&quot; -&gt; Message . configure_ack ( on_success : :term ) &quot;BAR&quot; -&gt; Message . configure_ack ( on_success : :nack ) message -&gt; message end end defp process_data ( data ) do String . upcase ( data ) end def handle_batch ( _ , messages , _ , _ ) do list = messages |&gt; Enum . map ( fn e -&gt; e . data end ) IO . puts ( &quot;Got a batch: \#{ inspect ( list ) } . Sending acknowledgements...&quot; ) messages end First, in handle_message/3 we update our messages' data individually by converting them to uppercase. Then, in the same callback, we're changing the success ack option of the message to :term if its content is &quot;FOO&quot; or to :nack if the message is &quot;BAR&quot; . In the end we print each batch in handle_batch/4 . It's not quite useful but should be enough for this guide.","ref":"broadway.html#getting-started"},{"type":"extras","title":"Using Broadway with Jetstream - Running the Broadway pipeline","doc":"Once we have our pipeline fully defined, we need to add it as a child in the supervision tree. Most applications have a supervision tree defined at lib/my_app/application.ex . children = [ { MyBroadway , [ ] } ] Supervisor . start_link ( children , strategy : :one_for_one ) You can now test the pipeline. Let's start the application: iex -S mix Use Gnat API to send messages to your stream: Gnat . pub ( :gnat , &quot;test_subject&quot; , &quot;foo&quot; ) Gnat . pub ( :gnat , &quot;test_subject&quot; , &quot;bar&quot; ) Gnat . pub ( :gnat , &quot;test_subject&quot; , &quot;baz&quot; ) Batcher should then print: Got a batch : [ &quot;FOO&quot; , &quot;BAR&quot; , &quot;BAZ&quot; ] . Sending acknowledgements ...","ref":"broadway.html#running-the-broadway-pipeline"}]